package descartes.kieker4dql.dqlconnector.structures.resources;

import descartes.kieker4dql.dqlconnector.structures.AbstractCollectorMap;
import descartes.kieker4dql.dqlconnector.structures.Trace;


/**
 * 
 * @author Jack
 *
 */
public class ResourceMap extends AbstractCollectorMap<ResourceMapKey,ResourceMapValue>{

	/**
	 * 
	 */
	private static final long serialVersionUID = -8890897718481861777L;
	private static ResourceMap instance;

	private ResourceMap(){};


	/**
	 * 
	 * @return Singleton instance
	 */
	public static synchronized ResourceMap getInstance () {
		if (ResourceMap.instance == null) {
			ResourceMap.instance = new ResourceMap();
		}
		return ResourceMap.instance;
	}


	@Override
	protected Object isUpdateValue(Object key, Object newValue) {
		ResourceMapValue newResourceValue = null;
		if (newValue instanceof ResourceMapValue) {
			newResourceValue = (ResourceMapValue) newValue;
			ResourceMapValue oldValue = (ResourceMapValue) get(key);
			long timestamp = newResourceValue.getCurrentTimestamp();
			double utilization = newResourceValue.getCurrentData();
			ResourceMapValue enhancedValue = oldValue.enhance(timestamp,utilization);
			return enhancedValue;
		} 
		return null;
	}


	@Override
	public void pushToTrace(Trace trace) {
		// TODO Auto-generated method stub
		
	}



}
